# rrhet_test_catalog_api

RrhetTestCatalogApi - JavaScript client for rrhet_test_catalog_api
TestCatalogueSample
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install rrhet_test_catalog_api --save
```

##### Local development

To use the library locally without publishing to a remote npm registry, first install the dependencies by changing 
into the directory containing `package.json` (and this README). Let's call this `JAVASCRIPT_CLIENT_DIR`. Then run:

```shell
npm install
```

Next, [link](https://docs.npmjs.com/cli/link) it globally in npm with the following, also from `JAVASCRIPT_CLIENT_DIR`:

```shell
npm link
```

Finally, switch to the directory you want to use your rrhet_test_catalog_api from, and run:

```shell
npm link /path/to/<JAVASCRIPT_CLIENT_DIR>
```

You should now be able to `require('rrhet_test_catalog_api')` in javascript files from the directory you ran the last 
command above from.

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/YOUR_USERNAME/rrhet_test_catalog_api
then install it via:

```shell
    npm install YOUR_USERNAME/rrhet_test_catalog_api --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file, that's to say your javascript file where you actually 
use this library):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

### Webpack Configuration

Using Webpack you may encounter the following error: "Module not found: Error:
Cannot resolve module", most certainly you should disable AMD loader. Add/merge
the following section to your webpack config:

```javascript
module: {
  rules: [
    {
      parser: {
        amd: false
      }
    }
  ]
}
```

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var api = new RrhetTestCatalogApi.DefaultApi()

var uuid = "uuid_example"; // {String} 

var extension = "extension_example"; // {String} 

var token = "token_example"; // {String} The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.fileDownloadGet(uuid, extension, token, callback);

```

## Documentation for API Endpoints

All URIs are relative to *https://testcatalog-api.rrhemergingtech.org/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*RrhetTestCatalogApi.DefaultApi* | [**fileDownloadGet**](docs/DefaultApi.md#fileDownloadGet) | **GET** /file-download | 
*RrhetTestCatalogApi.DefaultApi* | [**fileUploadPost**](docs/DefaultApi.md#fileUploadPost) | **POST** /file-upload | Upload a file
*RrhetTestCatalogApi.DefaultApi* | [**globalRangePropertiesGet**](docs/DefaultApi.md#globalRangePropertiesGet) | **GET** /global-range-properties | Get all global range properties
*RrhetTestCatalogApi.DefaultApi* | [**globalRangePropertiesIdDelete**](docs/DefaultApi.md#globalRangePropertiesIdDelete) | **DELETE** /global-range-properties/{id} | Deletes a global range property
*RrhetTestCatalogApi.DefaultApi* | [**globalRangePropertiesIdGet**](docs/DefaultApi.md#globalRangePropertiesIdGet) | **GET** /global-range-properties/{id} | 
*RrhetTestCatalogApi.DefaultApi* | [**globalRangePropertiesIdPut**](docs/DefaultApi.md#globalRangePropertiesIdPut) | **PUT** /global-range-properties/{id} | Update an existing global range property
*RrhetTestCatalogApi.DefaultApi* | [**globalRangePropertiesPost**](docs/DefaultApi.md#globalRangePropertiesPost) | **POST** /global-range-properties | Upload a global range property
*RrhetTestCatalogApi.DefaultApi* | [**propertyJournalsGet**](docs/DefaultApi.md#propertyJournalsGet) | **GET** /property-journals | Get all property journals
*RrhetTestCatalogApi.DefaultApi* | [**propertyJournalsIdDelete**](docs/DefaultApi.md#propertyJournalsIdDelete) | **DELETE** /property-journals/{id} | Deletes a property journal
*RrhetTestCatalogApi.DefaultApi* | [**propertyJournalsIdGet**](docs/DefaultApi.md#propertyJournalsIdGet) | **GET** /property-journals/{id} | 
*RrhetTestCatalogApi.DefaultApi* | [**propertyJournalsIdPut**](docs/DefaultApi.md#propertyJournalsIdPut) | **PUT** /property-journals/{id} | Update an existing property journal
*RrhetTestCatalogApi.DefaultApi* | [**propertyJournalsPost**](docs/DefaultApi.md#propertyJournalsPost) | **POST** /property-journals | Upload a property journal
*RrhetTestCatalogApi.DefaultApi* | [**ptsDownloadIdGet**](docs/DefaultApi.md#ptsDownloadIdGet) | **GET** /pts-download/{id} | 
*RrhetTestCatalogApi.DefaultApi* | [**ptsDownloadPost**](docs/DefaultApi.md#ptsDownloadPost) | **POST** /pts-download | 
*RrhetTestCatalogApi.DefaultApi* | [**searchCriteriaGet**](docs/DefaultApi.md#searchCriteriaGet) | **GET** /search-criteria | Get all search criteria fields
*RrhetTestCatalogApi.DefaultApi* | [**searchCriteriaIdDelete**](docs/DefaultApi.md#searchCriteriaIdDelete) | **DELETE** /search-criteria/{id} | Deletes a Search Criteria
*RrhetTestCatalogApi.DefaultApi* | [**searchCriteriaIdGet**](docs/DefaultApi.md#searchCriteriaIdGet) | **GET** /search-criteria/{id} | 
*RrhetTestCatalogApi.DefaultApi* | [**searchCriteriaIdPut**](docs/DefaultApi.md#searchCriteriaIdPut) | **PUT** /search-criteria/{id} | Update an existing Search Criteria
*RrhetTestCatalogApi.DefaultApi* | [**searchCriteriaPost**](docs/DefaultApi.md#searchCriteriaPost) | **POST** /search-criteria | Upload the info
*RrhetTestCatalogApi.DefaultApi* | [**searchResultsGet**](docs/DefaultApi.md#searchResultsGet) | **GET** /search-results | 
*RrhetTestCatalogApi.DefaultApi* | [**testCatalogSpreadsheetGet**](docs/DefaultApi.md#testCatalogSpreadsheetGet) | **GET** /test-catalog/spreadsheet | Get the test-catalog spreadsheet
*RrhetTestCatalogApi.DefaultApi* | [**testCatalogUploadExcelSpreadsheetPost**](docs/DefaultApi.md#testCatalogUploadExcelSpreadsheetPost) | **POST** /test-catalog/spreadsheet | Upload a test-catalog spreadsheet
*RrhetTestCatalogApi.DefaultApi* | [**testPropertiesGet**](docs/DefaultApi.md#testPropertiesGet) | **GET** /test-properties | Get all test properties
*RrhetTestCatalogApi.DefaultApi* | [**testPropertiesIdDelete**](docs/DefaultApi.md#testPropertiesIdDelete) | **DELETE** /test-properties/{id} | Deletes a test property
*RrhetTestCatalogApi.DefaultApi* | [**testPropertiesIdGet**](docs/DefaultApi.md#testPropertiesIdGet) | **GET** /test-properties/{id} | 
*RrhetTestCatalogApi.DefaultApi* | [**testPropertiesIdPut**](docs/DefaultApi.md#testPropertiesIdPut) | **PUT** /test-properties/{id} | Update an existing test property
*RrhetTestCatalogApi.DefaultApi* | [**testPropertiesPost**](docs/DefaultApi.md#testPropertiesPost) | **POST** /test-properties | Upload a test property
*RrhetTestCatalogApi.DefaultApi* | [**testsGet**](docs/DefaultApi.md#testsGet) | **GET** /tests | Get all tests
*RrhetTestCatalogApi.DefaultApi* | [**testsIdDelete**](docs/DefaultApi.md#testsIdDelete) | **DELETE** /tests/{id} | Deletes a test
*RrhetTestCatalogApi.DefaultApi* | [**testsIdGet**](docs/DefaultApi.md#testsIdGet) | **GET** /tests/{id} | 
*RrhetTestCatalogApi.DefaultApi* | [**testsIdPut**](docs/DefaultApi.md#testsIdPut) | **PUT** /tests/{id} | Update an existing test
*RrhetTestCatalogApi.DefaultApi* | [**testsPost**](docs/DefaultApi.md#testsPost) | **POST** /tests | Upload a test
*RrhetTestCatalogApi.DefaultApi* | [**usersGet**](docs/DefaultApi.md#usersGet) | **GET** /users | 


## Documentation for Models

 - [RrhetTestCatalogApi.DataItem](docs/DataItem.md)
 - [RrhetTestCatalogApi.DataRow](docs/DataRow.md)
 - [RrhetTestCatalogApi.DataRows](docs/DataRows.md)
 - [RrhetTestCatalogApi.FieldDefinition](docs/FieldDefinition.md)
 - [RrhetTestCatalogApi.GlobalRangeProperty](docs/GlobalRangeProperty.md)
 - [RrhetTestCatalogApi.GlobalReferenceRangeParameterIndex](docs/GlobalReferenceRangeParameterIndex.md)
 - [RrhetTestCatalogApi.Location](docs/Location.md)
 - [RrhetTestCatalogApi.PTSInfo](docs/PTSInfo.md)
 - [RrhetTestCatalogApi.Permissions](docs/Permissions.md)
 - [RrhetTestCatalogApi.PropertyJournal](docs/PropertyJournal.md)
 - [RrhetTestCatalogApi.SearchCriteria](docs/SearchCriteria.md)
 - [RrhetTestCatalogApi.SearchResult](docs/SearchResult.md)
 - [RrhetTestCatalogApi.StabilitySource](docs/StabilitySource.md)
 - [RrhetTestCatalogApi.Test](docs/Test.md)
 - [RrhetTestCatalogApi.TestDefinition](docs/TestDefinition.md)
 - [RrhetTestCatalogApi.TestDefinitionSection](docs/TestDefinitionSection.md)
 - [RrhetTestCatalogApi.TestLocation](docs/TestLocation.md)
 - [RrhetTestCatalogApi.TestProperty](docs/TestProperty.md)
 - [RrhetTestCatalogApi.UploadedFile](docs/UploadedFile.md)
 - [RrhetTestCatalogApi.User](docs/User.md)


## Documentation for Authorization

 All endpoints do not require authorization.

