# RrhetTestCatalogApi.DefaultApi

All URIs are relative to *https://testcatalog-api.rrhemergingtech.org/v2*

Method | HTTP request | Description
------------- | ------------- | -------------
[**fileDownloadGet**](DefaultApi.md#fileDownloadGet) | **GET** /file-download | 
[**fileUploadPost**](DefaultApi.md#fileUploadPost) | **POST** /file-upload | Upload a file
[**globalRangePropertiesGet**](DefaultApi.md#globalRangePropertiesGet) | **GET** /global-range-properties | Get all global range properties
[**globalRangePropertiesIdDelete**](DefaultApi.md#globalRangePropertiesIdDelete) | **DELETE** /global-range-properties/{id} | Deletes a global range property
[**globalRangePropertiesIdGet**](DefaultApi.md#globalRangePropertiesIdGet) | **GET** /global-range-properties/{id} | 
[**globalRangePropertiesIdPut**](DefaultApi.md#globalRangePropertiesIdPut) | **PUT** /global-range-properties/{id} | Update an existing global range property
[**globalRangePropertiesPost**](DefaultApi.md#globalRangePropertiesPost) | **POST** /global-range-properties | Upload a global range property
[**propertyJournalsGet**](DefaultApi.md#propertyJournalsGet) | **GET** /property-journals | Get all property journals
[**propertyJournalsIdDelete**](DefaultApi.md#propertyJournalsIdDelete) | **DELETE** /property-journals/{id} | Deletes a property journal
[**propertyJournalsIdGet**](DefaultApi.md#propertyJournalsIdGet) | **GET** /property-journals/{id} | 
[**propertyJournalsIdPut**](DefaultApi.md#propertyJournalsIdPut) | **PUT** /property-journals/{id} | Update an existing property journal
[**propertyJournalsPost**](DefaultApi.md#propertyJournalsPost) | **POST** /property-journals | Upload a property journal
[**ptsDownloadIdGet**](DefaultApi.md#ptsDownloadIdGet) | **GET** /pts-download/{id} | 
[**ptsDownloadPost**](DefaultApi.md#ptsDownloadPost) | **POST** /pts-download | 
[**searchCriteriaGet**](DefaultApi.md#searchCriteriaGet) | **GET** /search-criteria | Get all search criteria fields
[**searchCriteriaIdDelete**](DefaultApi.md#searchCriteriaIdDelete) | **DELETE** /search-criteria/{id} | Deletes a Search Criteria
[**searchCriteriaIdGet**](DefaultApi.md#searchCriteriaIdGet) | **GET** /search-criteria/{id} | 
[**searchCriteriaIdPut**](DefaultApi.md#searchCriteriaIdPut) | **PUT** /search-criteria/{id} | Update an existing Search Criteria
[**searchCriteriaPost**](DefaultApi.md#searchCriteriaPost) | **POST** /search-criteria | Upload the info
[**searchResultsGet**](DefaultApi.md#searchResultsGet) | **GET** /search-results | 
[**testCatalogSpreadsheetGet**](DefaultApi.md#testCatalogSpreadsheetGet) | **GET** /test-catalog/spreadsheet | Get the test-catalog spreadsheet
[**testCatalogUploadExcelSpreadsheetPost**](DefaultApi.md#testCatalogUploadExcelSpreadsheetPost) | **POST** /test-catalog/spreadsheet | Upload a test-catalog spreadsheet
[**testPropertiesGet**](DefaultApi.md#testPropertiesGet) | **GET** /test-properties | Get all test properties
[**testPropertiesIdDelete**](DefaultApi.md#testPropertiesIdDelete) | **DELETE** /test-properties/{id} | Deletes a test property
[**testPropertiesIdGet**](DefaultApi.md#testPropertiesIdGet) | **GET** /test-properties/{id} | 
[**testPropertiesIdPut**](DefaultApi.md#testPropertiesIdPut) | **PUT** /test-properties/{id} | Update an existing test property
[**testPropertiesPost**](DefaultApi.md#testPropertiesPost) | **POST** /test-properties | Upload a test property
[**testsGet**](DefaultApi.md#testsGet) | **GET** /tests | Get all tests
[**testsIdDelete**](DefaultApi.md#testsIdDelete) | **DELETE** /tests/{id} | Deletes a test
[**testsIdGet**](DefaultApi.md#testsIdGet) | **GET** /tests/{id} | 
[**testsIdPut**](DefaultApi.md#testsIdPut) | **PUT** /tests/{id} | Update an existing test
[**testsPost**](DefaultApi.md#testsPost) | **POST** /tests | Upload a test
[**usersGet**](DefaultApi.md#usersGet) | **GET** /users | 


<a name="fileDownloadGet"></a>
# **fileDownloadGet**
> UploadedFile fileDownloadGet(uuid, extension, token)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var uuid = "uuid_example"; // String | 

var extension = "extension_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.fileDownloadGet(uuid, extension, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **uuid** | **String**|  | 
 **extension** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**UploadedFile**](UploadedFile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="fileUploadPost"></a>
# **fileUploadPost**
> UploadedFile fileUploadPost(token, opts)

Upload a file

upload a file

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token

var opts = { 
  'additionalMetadata': "additionalMetadata_example", // String | Additional data to pass to server
  'file': "/path/to/file.txt" // File | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.fileUploadPost(token, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 
 **additionalMetadata** | **String**| Additional data to pass to server | [optional] 
 **file** | **File**|  | [optional] 

### Return type

[**UploadedFile**](UploadedFile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

<a name="globalRangePropertiesGet"></a>
# **globalRangePropertiesGet**
> [GlobalRangeProperty] globalRangePropertiesGet(token)

Get all global range properties

get all global range properties

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.globalRangePropertiesGet(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 

### Return type

[**[GlobalRangeProperty]**](GlobalRangeProperty.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="globalRangePropertiesIdDelete"></a>
# **globalRangePropertiesIdDelete**
> globalRangePropertiesIdDelete(id, token)

Deletes a global range property

deletes a global range property with the specified id

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.globalRangePropertiesIdDelete(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="globalRangePropertiesIdGet"></a>
# **globalRangePropertiesIdGet**
> GlobalRangeProperty globalRangePropertiesIdGet(id, token)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.globalRangePropertiesIdGet(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**GlobalRangeProperty**](GlobalRangeProperty.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="globalRangePropertiesIdPut"></a>
# **globalRangePropertiesIdPut**
> globalRangePropertiesIdPut(body, id, token)

Update an existing global range property

update an existing global range property

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.GlobalRangeProperty(); // GlobalRangeProperty | Global range property object that needs to be added to the store

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.globalRangePropertiesIdPut(body, id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**GlobalRangeProperty**](GlobalRangeProperty.md)| Global range property object that needs to be added to the store | 
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="globalRangePropertiesPost"></a>
# **globalRangePropertiesPost**
> globalRangePropertiesPost(body, token)

Upload a global range property



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.GlobalRangeProperty(); // GlobalRangeProperty | Global range property object that needs to be added to the store

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.globalRangePropertiesPost(body, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**GlobalRangeProperty**](GlobalRangeProperty.md)| Global range property object that needs to be added to the store | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="propertyJournalsGet"></a>
# **propertyJournalsGet**
> [PropertyJournal] propertyJournalsGet(token)

Get all property journals

get all property journals

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.propertyJournalsGet(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 

### Return type

[**[PropertyJournal]**](PropertyJournal.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="propertyJournalsIdDelete"></a>
# **propertyJournalsIdDelete**
> propertyJournalsIdDelete(id, token)

Deletes a property journal

deletes a property journal with the specified id

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.propertyJournalsIdDelete(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="propertyJournalsIdGet"></a>
# **propertyJournalsIdGet**
> PropertyJournal propertyJournalsIdGet(id, token)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.propertyJournalsIdGet(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**PropertyJournal**](PropertyJournal.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="propertyJournalsIdPut"></a>
# **propertyJournalsIdPut**
> propertyJournalsIdPut(body, id, token)

Update an existing property journal

update an existing property journal

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.PropertyJournal(); // PropertyJournal | Property journal object that needs to be added to the store

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.propertyJournalsIdPut(body, id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PropertyJournal**](PropertyJournal.md)| Property journal object that needs to be added to the store | 
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="propertyJournalsPost"></a>
# **propertyJournalsPost**
> propertyJournalsPost(body, token)

Upload a property journal



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.PropertyJournal(); // PropertyJournal | Property journal object that needs to be added to the store

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.propertyJournalsPost(body, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PropertyJournal**](PropertyJournal.md)| Property journal object that needs to be added to the store | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="ptsDownloadIdGet"></a>
# **ptsDownloadIdGet**
> UploadedFile ptsDownloadIdGet(id, token)



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.ptsDownloadIdGet(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**UploadedFile**](UploadedFile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: binary/octet-stream

<a name="ptsDownloadPost"></a>
# **ptsDownloadPost**
> UploadedFile ptsDownloadPost(body, token)



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.PTSInfo(); // PTSInfo | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.ptsDownloadPost(body, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PTSInfo**](PTSInfo.md)|  | 
 **token** | **String**| The authorization token | 

### Return type

[**UploadedFile**](UploadedFile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="searchCriteriaGet"></a>
# **searchCriteriaGet**
> [SearchCriteria] searchCriteriaGet(token)

Get all search criteria fields

get all search criteria fields

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.searchCriteriaGet(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 

### Return type

[**[SearchCriteria]**](SearchCriteria.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="searchCriteriaIdDelete"></a>
# **searchCriteriaIdDelete**
> searchCriteriaIdDelete(id, token)

Deletes a Search Criteria

deletes a Search Criteria with the specified id

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.searchCriteriaIdDelete(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="searchCriteriaIdGet"></a>
# **searchCriteriaIdGet**
> SearchCriteria searchCriteriaIdGet(id, token)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.searchCriteriaIdGet(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**SearchCriteria**](SearchCriteria.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="searchCriteriaIdPut"></a>
# **searchCriteriaIdPut**
> searchCriteriaIdPut(body, id, token)

Update an existing Search Criteria

update an existing search criteria

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.SearchCriteria(); // SearchCriteria | Search Criteria object that needs to be added to the store

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.searchCriteriaIdPut(body, id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SearchCriteria**](SearchCriteria.md)| Search Criteria object that needs to be added to the store | 
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="searchCriteriaPost"></a>
# **searchCriteriaPost**
> searchCriteriaPost(body, token)

Upload the info



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.SearchCriteria(); // SearchCriteria | SearchCriteria object that needs to be added to the store

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.searchCriteriaPost(body, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SearchCriteria**](SearchCriteria.md)| SearchCriteria object that needs to be added to the store | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="searchResultsGet"></a>
# **searchResultsGet**
> [SearchResult] searchResultsGet(token, opts)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token

var opts = { 
  'searchTerm': "searchTerm_example", // String | 
  'fields': "fields_example", // String | 
  'status': "status_example", // String | 
  'createdBy': "createdBy_example", // String | 
  'test': "test_example", // String | 
  'location': "location_example", // String | 
  'labSection': "labSection_example", // String | 
  'sexM': false, // Boolean | 
  'sexF': false, // Boolean | 
  'sexMF': false, // Boolean | 
  'ageRange': "ageRange_example", // String | 
  'returnLocations': true, // Boolean | 
  'returnPropertyJournals': false, // Boolean | 
  'returnHiddenTestLocations': false, // Boolean | 
  'startDate': "startDate_example", // String | yyyy-MM-dd
  'endDate': "endDate_example" // String | yyyy-MM-dd
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.searchResultsGet(token, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 
 **searchTerm** | **String**|  | [optional] 
 **fields** | **String**|  | [optional] 
 **status** | **String**|  | [optional] 
 **createdBy** | **String**|  | [optional] 
 **test** | **String**|  | [optional] 
 **location** | **String**|  | [optional] 
 **labSection** | **String**|  | [optional] 
 **sexM** | **Boolean**|  | [optional] [default to false]
 **sexF** | **Boolean**|  | [optional] [default to false]
 **sexMF** | **Boolean**|  | [optional] [default to false]
 **ageRange** | **String**|  | [optional] 
 **returnLocations** | **Boolean**|  | [optional] [default to true]
 **returnPropertyJournals** | **Boolean**|  | [optional] [default to false]
 **returnHiddenTestLocations** | **Boolean**|  | [optional] [default to false]
 **startDate** | **String**| yyyy-MM-dd | [optional] 
 **endDate** | **String**| yyyy-MM-dd | [optional] 

### Return type

[**[SearchResult]**](SearchResult.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testCatalogSpreadsheetGet"></a>
# **testCatalogSpreadsheetGet**
> testCatalogSpreadsheetGet()

Get the test-catalog spreadsheet

get the test-catalog spreadsheet

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.testCatalogSpreadsheetGet(callback);
```

### Parameters
This endpoint does not need any parameter.

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testCatalogUploadExcelSpreadsheetPost"></a>
# **testCatalogUploadExcelSpreadsheetPost**
> testCatalogUploadExcelSpreadsheetPost(token, opts)

Upload a test-catalog spreadsheet

upload a test-catalog spreadsheet

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token

var opts = { 
  'additionalMetadata': "additionalMetadata_example", // String | Additional data to pass to server
  'file': "/path/to/file.txt" // File | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.testCatalogUploadExcelSpreadsheetPost(token, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 
 **additionalMetadata** | **String**| Additional data to pass to server | [optional] 
 **file** | **File**|  | [optional] 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

<a name="testPropertiesGet"></a>
# **testPropertiesGet**
> [TestProperty] testPropertiesGet(token)

Get all test properties

get all test properties

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testPropertiesGet(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 

### Return type

[**[TestProperty]**](TestProperty.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testPropertiesIdDelete"></a>
# **testPropertiesIdDelete**
> testPropertiesIdDelete(id, token)

Deletes a test property

deletes a test property with the specified id

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.testPropertiesIdDelete(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testPropertiesIdGet"></a>
# **testPropertiesIdGet**
> TestProperty testPropertiesIdGet(id, token)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testPropertiesIdGet(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**TestProperty**](TestProperty.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testPropertiesIdPut"></a>
# **testPropertiesIdPut**
> TestProperty testPropertiesIdPut(body, id, token)

Update an existing test property

update an existing test property

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.TestProperty(); // TestProperty | Test property object that needs to be added to the store

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testPropertiesIdPut(body, id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TestProperty**](TestProperty.md)| Test property object that needs to be added to the store | 
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**TestProperty**](TestProperty.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="testPropertiesPost"></a>
# **testPropertiesPost**
> TestProperty testPropertiesPost(body, token)

Upload a test property



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.TestProperty(); // TestProperty | Test property object that needs to be added to the store

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testPropertiesPost(body, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TestProperty**](TestProperty.md)| Test property object that needs to be added to the store | 
 **token** | **String**| The authorization token | 

### Return type

[**TestProperty**](TestProperty.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="testsGet"></a>
# **testsGet**
> [Test] testsGet(token, opts)

Get all tests

get all tests

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token

var opts = { 
  'searchTerm': "searchTerm_example", // String | 
  'location': "location_example", // String | 
  'labSection': "labSection_example" // String | 
};

var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testsGet(token, opts, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 
 **searchTerm** | **String**|  | [optional] 
 **location** | **String**|  | [optional] 
 **labSection** | **String**|  | [optional] 

### Return type

[**[Test]**](Test.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testsIdDelete"></a>
# **testsIdDelete**
> testsIdDelete(id, token)

Deletes a test

deletes a test with the specified id

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.testsIdDelete(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testsIdGet"></a>
# **testsIdGet**
> Test testsIdGet(id, token)





### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testsIdGet(id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**Test**](Test.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="testsIdPut"></a>
# **testsIdPut**
> Test testsIdPut(body, id, token)

Update an existing test

update an existing test

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.Test(); // Test | Test object that needs to be added to the store

var id = "id_example"; // String | 

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testsIdPut(body, id, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Test**](Test.md)| Test object that needs to be added to the store | 
 **id** | **String**|  | 
 **token** | **String**| The authorization token | 

### Return type

[**Test**](Test.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="testsPost"></a>
# **testsPost**
> Test testsPost(body, token)

Upload a test



### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var body = new RrhetTestCatalogApi.Test(); // Test | Test object that needs to be added to the store

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.testsPost(body, token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Test**](Test.md)| Test object that needs to be added to the store | 
 **token** | **String**| The authorization token | 

### Return type

[**Test**](Test.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="usersGet"></a>
# **usersGet**
> User usersGet(token)



Get the user from the token

### Example
```javascript
var RrhetTestCatalogApi = require('rrhet_test_catalog_api');

var apiInstance = new RrhetTestCatalogApi.DefaultApi();

var token = "token_example"; // String | The authorization token


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.usersGet(token, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token** | **String**| The authorization token | 

### Return type

[**User**](User.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

