/**
 * RRHET Test Catalog API
 * TestCatalogueSample
 *
 * OpenAPI spec version: 1.0.0
 * Contact: umang.garg@rochesterregional.org
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/GlobalRangeProperty', 'model/PTSInfo', 'model/PropertyJournal', 'model/SearchCriteria', 'model/SearchResult', 'model/Test', 'model/TestProperty', 'model/UploadedFile', 'model/User'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../model/GlobalRangeProperty'), require('../model/PTSInfo'), require('../model/PropertyJournal'), require('../model/SearchCriteria'), require('../model/SearchResult'), require('../model/Test'), require('../model/TestProperty'), require('../model/UploadedFile'), require('../model/User'));
  } else {
    // Browser globals (root is window)
    if (!root.RrhetTestCatalogApi) {
      root.RrhetTestCatalogApi = {};
    }
    root.RrhetTestCatalogApi.DefaultApi = factory(root.RrhetTestCatalogApi.ApiClient, root.RrhetTestCatalogApi.GlobalRangeProperty, root.RrhetTestCatalogApi.PTSInfo, root.RrhetTestCatalogApi.PropertyJournal, root.RrhetTestCatalogApi.SearchCriteria, root.RrhetTestCatalogApi.SearchResult, root.RrhetTestCatalogApi.Test, root.RrhetTestCatalogApi.TestProperty, root.RrhetTestCatalogApi.UploadedFile, root.RrhetTestCatalogApi.User);
  }
}(this, function(ApiClient, GlobalRangeProperty, PTSInfo, PropertyJournal, SearchCriteria, SearchResult, Test, TestProperty, UploadedFile, User) {
  'use strict';

  /**
   * Default service.
   * @module api/DefaultApi
   * @version 1.0.0
   */

  /**
   * Constructs a new DefaultApi. 
   * @alias module:api/DefaultApi
   * @class
   * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
   * default to {@link module:ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the fileDownloadGet operation.
     * @callback module:api/DefaultApi~fileDownloadGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UploadedFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} uuid 
     * @param {String} extension 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~fileDownloadGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UploadedFile}
     */
    this.fileDownloadGet = function(uuid, extension, token, callback) {
      var postBody = null;

      // verify the required parameter 'uuid' is set
      if (uuid === undefined || uuid === null) {
        throw new Error("Missing the required parameter 'uuid' when calling fileDownloadGet");
      }

      // verify the required parameter 'extension' is set
      if (extension === undefined || extension === null) {
        throw new Error("Missing the required parameter 'extension' when calling fileDownloadGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling fileDownloadGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'uuid': uuid,
        'extension': extension,
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = UploadedFile;

      return this.apiClient.callApi(
        '/file-download', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the fileUploadPost operation.
     * @callback module:api/DefaultApi~fileUploadPostCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UploadedFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload a file
     * upload a file
     * @param {String} token The authorization token
     * @param {Object} opts Optional parameters
     * @param {String} opts.additionalMetadata Additional data to pass to server
     * @param {File} opts.file 
     * @param {module:api/DefaultApi~fileUploadPostCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UploadedFile}
     */
    this.fileUploadPost = function(token, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling fileUploadPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'additionalMetadata': opts['additionalMetadata'],
        'file': opts['file']
      };

      var authNames = [];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json'];
      var returnType = UploadedFile;

      return this.apiClient.callApi(
        '/file-upload', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the globalRangePropertiesGet operation.
     * @callback module:api/DefaultApi~globalRangePropertiesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/GlobalRangeProperty>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all global range properties
     * get all global range properties
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~globalRangePropertiesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/GlobalRangeProperty>}
     */
    this.globalRangePropertiesGet = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling globalRangePropertiesGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [GlobalRangeProperty];

      return this.apiClient.callApi(
        '/global-range-properties', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the globalRangePropertiesIdDelete operation.
     * @callback module:api/DefaultApi~globalRangePropertiesIdDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a global range property
     * deletes a global range property with the specified id
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~globalRangePropertiesIdDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.globalRangePropertiesIdDelete = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling globalRangePropertiesIdDelete");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling globalRangePropertiesIdDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/global-range-properties/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the globalRangePropertiesIdGet operation.
     * @callback module:api/DefaultApi~globalRangePropertiesIdGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/GlobalRangeProperty} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~globalRangePropertiesIdGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/GlobalRangeProperty}
     */
    this.globalRangePropertiesIdGet = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling globalRangePropertiesIdGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling globalRangePropertiesIdGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = GlobalRangeProperty;

      return this.apiClient.callApi(
        '/global-range-properties/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the globalRangePropertiesIdPut operation.
     * @callback module:api/DefaultApi~globalRangePropertiesIdPutCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an existing global range property
     * update an existing global range property
     * @param {module:model/GlobalRangeProperty} body Global range property object that needs to be added to the store
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~globalRangePropertiesIdPutCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.globalRangePropertiesIdPut = function(body, id, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling globalRangePropertiesIdPut");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling globalRangePropertiesIdPut");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling globalRangePropertiesIdPut");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/global-range-properties/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the globalRangePropertiesPost operation.
     * @callback module:api/DefaultApi~globalRangePropertiesPostCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload a global range property
     * 
     * @param {module:model/GlobalRangeProperty} body Global range property object that needs to be added to the store
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~globalRangePropertiesPostCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.globalRangePropertiesPost = function(body, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling globalRangePropertiesPost");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling globalRangePropertiesPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/global-range-properties', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the propertyJournalsGet operation.
     * @callback module:api/DefaultApi~propertyJournalsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/PropertyJournal>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all property journals
     * get all property journals
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~propertyJournalsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/PropertyJournal>}
     */
    this.propertyJournalsGet = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling propertyJournalsGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [PropertyJournal];

      return this.apiClient.callApi(
        '/property-journals', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the propertyJournalsIdDelete operation.
     * @callback module:api/DefaultApi~propertyJournalsIdDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a property journal
     * deletes a property journal with the specified id
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~propertyJournalsIdDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.propertyJournalsIdDelete = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling propertyJournalsIdDelete");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling propertyJournalsIdDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/property-journals/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the propertyJournalsIdGet operation.
     * @callback module:api/DefaultApi~propertyJournalsIdGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/PropertyJournal} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~propertyJournalsIdGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/PropertyJournal}
     */
    this.propertyJournalsIdGet = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling propertyJournalsIdGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling propertyJournalsIdGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = PropertyJournal;

      return this.apiClient.callApi(
        '/property-journals/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the propertyJournalsIdPut operation.
     * @callback module:api/DefaultApi~propertyJournalsIdPutCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an existing property journal
     * update an existing property journal
     * @param {module:model/PropertyJournal} body Property journal object that needs to be added to the store
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~propertyJournalsIdPutCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.propertyJournalsIdPut = function(body, id, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling propertyJournalsIdPut");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling propertyJournalsIdPut");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling propertyJournalsIdPut");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/property-journals/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the propertyJournalsPost operation.
     * @callback module:api/DefaultApi~propertyJournalsPostCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload a property journal
     * 
     * @param {module:model/PropertyJournal} body Property journal object that needs to be added to the store
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~propertyJournalsPostCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.propertyJournalsPost = function(body, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling propertyJournalsPost");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling propertyJournalsPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/property-journals', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the ptsDownloadIdGet operation.
     * @callback module:api/DefaultApi~ptsDownloadIdGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UploadedFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~ptsDownloadIdGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UploadedFile}
     */
    this.ptsDownloadIdGet = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling ptsDownloadIdGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling ptsDownloadIdGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['binary/octet-stream'];
      var returnType = UploadedFile;

      return this.apiClient.callApi(
        '/pts-download/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the ptsDownloadPost operation.
     * @callback module:api/DefaultApi~ptsDownloadPostCallback
     * @param {String} error Error message, if any.
     * @param {module:model/UploadedFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {module:model/PTSInfo} body 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~ptsDownloadPostCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/UploadedFile}
     */
    this.ptsDownloadPost = function(body, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling ptsDownloadPost");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling ptsDownloadPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = UploadedFile;

      return this.apiClient.callApi(
        '/pts-download', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the searchCriteriaGet operation.
     * @callback module:api/DefaultApi~searchCriteriaGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SearchCriteria>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all search criteria fields
     * get all search criteria fields
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~searchCriteriaGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SearchCriteria>}
     */
    this.searchCriteriaGet = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling searchCriteriaGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SearchCriteria];

      return this.apiClient.callApi(
        '/search-criteria', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the searchCriteriaIdDelete operation.
     * @callback module:api/DefaultApi~searchCriteriaIdDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a Search Criteria
     * deletes a Search Criteria with the specified id
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~searchCriteriaIdDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.searchCriteriaIdDelete = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling searchCriteriaIdDelete");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling searchCriteriaIdDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/search-criteria/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the searchCriteriaIdGet operation.
     * @callback module:api/DefaultApi~searchCriteriaIdGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/SearchCriteria} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~searchCriteriaIdGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/SearchCriteria}
     */
    this.searchCriteriaIdGet = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling searchCriteriaIdGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling searchCriteriaIdGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = SearchCriteria;

      return this.apiClient.callApi(
        '/search-criteria/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the searchCriteriaIdPut operation.
     * @callback module:api/DefaultApi~searchCriteriaIdPutCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an existing Search Criteria
     * update an existing search criteria
     * @param {module:model/SearchCriteria} body Search Criteria object that needs to be added to the store
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~searchCriteriaIdPutCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.searchCriteriaIdPut = function(body, id, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling searchCriteriaIdPut");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling searchCriteriaIdPut");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling searchCriteriaIdPut");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/search-criteria/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the searchCriteriaPost operation.
     * @callback module:api/DefaultApi~searchCriteriaPostCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload the info
     * 
     * @param {module:model/SearchCriteria} body SearchCriteria object that needs to be added to the store
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~searchCriteriaPostCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.searchCriteriaPost = function(body, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling searchCriteriaPost");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling searchCriteriaPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/search-criteria', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the searchResultsGet operation.
     * @callback module:api/DefaultApi~searchResultsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/SearchResult>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} token The authorization token
     * @param {Object} opts Optional parameters
     * @param {String} opts.searchTerm 
     * @param {String} opts.fields 
     * @param {String} opts.status 
     * @param {String} opts.createdBy 
     * @param {String} opts.test 
     * @param {String} opts.location 
     * @param {String} opts.labSection 
     * @param {Boolean} opts.sexM  (default to false)
     * @param {Boolean} opts.sexF  (default to false)
     * @param {Boolean} opts.sexMF  (default to false)
     * @param {String} opts.ageRange 
     * @param {Boolean} opts.returnLocations  (default to true)
     * @param {Boolean} opts.returnPropertyJournals  (default to false)
     * @param {Boolean} opts.returnHiddenTestLocations  (default to false)
     * @param {String} opts.startDate yyyy-MM-dd
     * @param {String} opts.endDate yyyy-MM-dd
     * @param {module:api/DefaultApi~searchResultsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/SearchResult>}
     */
    this.searchResultsGet = function(token, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling searchResultsGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'search-term': opts['searchTerm'],
        'fields': opts['fields'],
        'status': opts['status'],
        'created-by': opts['createdBy'],
        'test': opts['test'],
        'location': opts['location'],
        'lab-section': opts['labSection'],
        'sexM': opts['sexM'],
        'sexF': opts['sexF'],
        'sexMF': opts['sexMF'],
        'age-range': opts['ageRange'],
        'returnLocations': opts['returnLocations'],
        'returnPropertyJournals': opts['returnPropertyJournals'],
        'returnHiddenTestLocations': opts['returnHiddenTestLocations'],
        'startDate': opts['startDate'],
        'endDate': opts['endDate'],
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [SearchResult];

      return this.apiClient.callApi(
        '/search-results', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testCatalogSpreadsheetGet operation.
     * @callback module:api/DefaultApi~testCatalogSpreadsheetGetCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get the test-catalog spreadsheet
     * get the test-catalog spreadsheet
     * @param {module:api/DefaultApi~testCatalogSpreadsheetGetCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.testCatalogSpreadsheetGet = function(callback) {
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/test-catalog/spreadsheet', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testCatalogUploadExcelSpreadsheetPost operation.
     * @callback module:api/DefaultApi~testCatalogUploadExcelSpreadsheetPostCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload a test-catalog spreadsheet
     * upload a test-catalog spreadsheet
     * @param {String} token The authorization token
     * @param {Object} opts Optional parameters
     * @param {String} opts.additionalMetadata Additional data to pass to server
     * @param {File} opts.file 
     * @param {module:api/DefaultApi~testCatalogUploadExcelSpreadsheetPostCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.testCatalogUploadExcelSpreadsheetPost = function(token, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testCatalogUploadExcelSpreadsheetPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'additionalMetadata': opts['additionalMetadata'],
        'file': opts['file']
      };

      var authNames = [];
      var contentTypes = ['multipart/form-data'];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/test-catalog/spreadsheet', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testPropertiesGet operation.
     * @callback module:api/DefaultApi~testPropertiesGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/TestProperty>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all test properties
     * get all test properties
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testPropertiesGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/TestProperty>}
     */
    this.testPropertiesGet = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testPropertiesGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [TestProperty];

      return this.apiClient.callApi(
        '/test-properties', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testPropertiesIdDelete operation.
     * @callback module:api/DefaultApi~testPropertiesIdDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a test property
     * deletes a test property with the specified id
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testPropertiesIdDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.testPropertiesIdDelete = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling testPropertiesIdDelete");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testPropertiesIdDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/test-properties/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testPropertiesIdGet operation.
     * @callback module:api/DefaultApi~testPropertiesIdGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TestProperty} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testPropertiesIdGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TestProperty}
     */
    this.testPropertiesIdGet = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling testPropertiesIdGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testPropertiesIdGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = TestProperty;

      return this.apiClient.callApi(
        '/test-properties/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testPropertiesIdPut operation.
     * @callback module:api/DefaultApi~testPropertiesIdPutCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TestProperty} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an existing test property
     * update an existing test property
     * @param {module:model/TestProperty} body Test property object that needs to be added to the store
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testPropertiesIdPutCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TestProperty}
     */
    this.testPropertiesIdPut = function(body, id, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling testPropertiesIdPut");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling testPropertiesIdPut");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testPropertiesIdPut");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TestProperty;

      return this.apiClient.callApi(
        '/test-properties/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testPropertiesPost operation.
     * @callback module:api/DefaultApi~testPropertiesPostCallback
     * @param {String} error Error message, if any.
     * @param {module:model/TestProperty} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload a test property
     * 
     * @param {module:model/TestProperty} body Test property object that needs to be added to the store
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testPropertiesPostCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/TestProperty}
     */
    this.testPropertiesPost = function(body, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling testPropertiesPost");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testPropertiesPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = TestProperty;

      return this.apiClient.callApi(
        '/test-properties', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testsGet operation.
     * @callback module:api/DefaultApi~testsGetCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:model/Test>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get all tests
     * get all tests
     * @param {String} token The authorization token
     * @param {Object} opts Optional parameters
     * @param {String} opts.searchTerm 
     * @param {String} opts.location 
     * @param {String} opts.labSection 
     * @param {module:api/DefaultApi~testsGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link Array.<module:model/Test>}
     */
    this.testsGet = function(token, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testsGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'search-term': opts['searchTerm'],
        'location': opts['location'],
        'lab-section': opts['labSection'],
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = [Test];

      return this.apiClient.callApi(
        '/tests', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testsIdDelete operation.
     * @callback module:api/DefaultApi~testsIdDeleteCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Deletes a test
     * deletes a test with the specified id
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testsIdDeleteCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.testsIdDelete = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling testsIdDelete");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testsIdDelete");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = null;

      return this.apiClient.callApi(
        '/tests/{id}', 'DELETE',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testsIdGet operation.
     * @callback module:api/DefaultApi~testsIdGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Test} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * 
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testsIdGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Test}
     */
    this.testsIdGet = function(id, token, callback) {
      var postBody = null;

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling testsIdGet");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testsIdGet");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = ['application/json'];
      var returnType = Test;

      return this.apiClient.callApi(
        '/tests/{id}', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testsIdPut operation.
     * @callback module:api/DefaultApi~testsIdPutCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Test} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update an existing test
     * update an existing test
     * @param {module:model/Test} body Test object that needs to be added to the store
     * @param {String} id 
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testsIdPutCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Test}
     */
    this.testsIdPut = function(body, id, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling testsIdPut");
      }

      // verify the required parameter 'id' is set
      if (id === undefined || id === null) {
        throw new Error("Missing the required parameter 'id' when calling testsIdPut");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testsIdPut");
      }


      var pathParams = {
        'id': id
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Test;

      return this.apiClient.callApi(
        '/tests/{id}', 'PUT',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the testsPost operation.
     * @callback module:api/DefaultApi~testsPostCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Test} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Upload a test
     * 
     * @param {module:model/Test} body Test object that needs to be added to the store
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~testsPostCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/Test}
     */
    this.testsPost = function(body, token, callback) {
      var postBody = body;

      // verify the required parameter 'body' is set
      if (body === undefined || body === null) {
        throw new Error("Missing the required parameter 'body' when calling testsPost");
      }

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling testsPost");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = ['application/json'];
      var accepts = ['application/json'];
      var returnType = Test;

      return this.apiClient.callApi(
        '/tests', 'POST',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the usersGet operation.
     * @callback module:api/DefaultApi~usersGetCallback
     * @param {String} error Error message, if any.
     * @param {module:model/User} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * 
     * Get the user from the token
     * @param {String} token The authorization token
     * @param {module:api/DefaultApi~usersGetCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link module:model/User}
     */
    this.usersGet = function(token, callback) {
      var postBody = null;

      // verify the required parameter 'token' is set
      if (token === undefined || token === null) {
        throw new Error("Missing the required parameter 'token' when calling usersGet");
      }


      var pathParams = {
      };
      var queryParams = {
        'token': token,
      };
      var collectionQueryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = [];
      var contentTypes = [];
      var accepts = [];
      var returnType = User;

      return this.apiClient.callApi(
        '/users', 'GET',
        pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
